;---------------------------------------------------------------
; RetroForth/Native 7.4
;---------------------------------------------------------------
include "macros.fasm"

use32
ORG 0x11000
MAIN:	call init_idt
	call init_serial
	call init_retroforth
	lidt [idt_pointer]
	sti
	jmp  interpret
;---------------------------------------------------------------

code 'emit', emit
mov dx, port
out dx, al
drop
ret

init_serial:
mov dx, port + 1
mov al, 0
out dx, al
mov al, $80
mov dx, port + 3
out dx, al
mov dx, port
mov al, $03
out dx, al
mov dx, port + 1
mov al, 0
out dx, al
mov dx, port + 3
mov al, $03
out dx, al
mov dx, port + 4
mov al, $0b
out dx, al
mov dx, port + 2
mov al, $c7
out dx, al
ret


code 'key', key
dup
xor eax, eax
mov dx, port_lsr
.A:
in al, dx
test al, 1
jz .A
mov dx, port
in al, dx
ret

port = $3f8
port_lsr = $3f8 + 5

include "idt.inc"
include "hdd.inc"

include "retroforth.asm"
